#ifndef BASE_H
#define BASE_H

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

/* #include <assert.h> */

/* // IO */
#include <iostream>
/* #include <fstream> */
/* // STL */
/* #include <vector> */
/* #include <string> */
/* #include <list> */
/* #include <map> */

using namespace std;

// il faut mettre ces typedef avant le include tools.h parce que tools
// utilise UINT

typedef unsigned char  BYTE;
typedef unsigned short U16;
typedef unsigned long  U32;
typedef unsigned int   UINT; 

#define RADIANS *57.29577951308232088

#define SQTHREE 1.732050807568877294
#define HSQTWO 0.70710678118655
#define SQTWO 1.4142135623731

#define TWOPI 6.283185307179586477
#define PI 3.141592653589793238
#define HALFPI 1.570796326794896619
#define QPI 0.785398163397448309

/* The camera application code (incorrectly) assumes that at a (z-)
   distance d our view point spans d units, i.e. our vertical field of
   vision is 2*atan(0.5) = 0.92729521800161 radians (53.1301023542
   degrees, rather than the 45 set in init.cpp). */
#define PFOV 0.92729521800161

// #define DEBUG

#include <GL/gl.h>
#include <SDL/SDL.h>

#include "tools.h"

/* Application */
#define APP_TITLE     "Breakout"
/* #define SCREEN_WIDTH  1366    // screen width pixels */
/* #define SCREEN_HEIGHT  768    // screen height pixels */
#define SCREEN_DEPTH    24    // bits per pixel

/* Mouse */
#define MOUSE_SENSITIVITY 100.0f
#define MOUSE_SPEED       0.002f
#define MOUSE_BUTTON_NONE   0
#define MOUSE_BUTTON_LEFT   1
#define MOUSE_BUTTON_CENTER 2
#define MOUSE_BUTTON_RIGHT  3

/* Misc */
#define FTOLERANCE    0.0001f

#endif // BASE_H
