#include <math.h>
//#include <unistd.h> // usleep

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#include "main.h"
#include "stone.h"

void body(void) {
  bool done = false;                                     // is our job done ? not yet !
  float lightPos[] = {0.1f,2.0f,0.5f,0};

  SDL_Event event;
  
  bool paused = false;
  Uint32 pausedsince; // SDL_GetTicks when "pause" was last activated
  Uint32 pausedtime = 0; // how many millis we have been paused so far

  Uint32 prev; // game time of previous frame
  Uint32 now=SDL_GetTicks(); // game time (stops when paused)
  
  resetCam();

  while(! done)                                          // as long as our job's not done
    {
      SDL_WaitEvent(0);

      if (!paused) {
	prev=now;
      //      now += 10;
	now=SDL_GetTicks()-pausedtime;
      }

      while (SDL_PollEvent(& event))
        {
	  switch (event.type)
            {
	    case SDL_QUIT :
	      SDL_ShowCursor(SDL_ENABLE);
	      done=true;
	      break;
	    case SDL_KEYDOWN :
	      //if (event.key.type==SDL_KEYDOWN) {
 		switch (event.key.keysym.sym) {
		case SDLK_q:
		  SDL_ShowCursor(SDL_ENABLE);
		  done=true;
		  break;
		case SDLK_n:
		  level->skip();
		  // levelDone=true;
		  break;
		case SDLK_p: // switch pause
		  if (paused) {
		    pausedtime += SDL_GetTicks()-pausedsince;
		    paused = false;
		  } else {
		    pausedsince = SDL_GetTicks();
		    paused = true;
		  }
		  break;
// 		case SDLK_LEFT:
// 		  pad.move(-1);
// 		  break;
// 		case SDLK_RIGHT:
// 		  pad.move(1);
// 		  break;
// 		case SDLK_UP:
// 		  pad.climb(1);
// 		  break;
// 		case SDLK_DOWN:
// 		  pad.climb(-1);
// 		  break;
// 		case SDLK_SPACE:
// 		  pad.grab();
// 		  break;
// 		case ',':
// 		  pad.push(-1);
// 		  break;
// 		case '.':
// 		  pad.push(1);
// 		  break;
 		default:
 		  break;
 		}
		//	      } else {
		//		printf("down but not down\n");
		//}
		break;
	    // case SDL_KEYUP :           
	    //   if (event.key.keysym.sym==SDLK_LEFT ||
	    // 	  event.key.keysym.sym==SDLK_RIGHT ||
	    // 	  event.key.keysym.sym==SDLK_UP ||
	    // 	  event.key.keysym.sym==SDLK_DOWN) {
	    // 	//		pad.stop();
	    //   }
	    //   break;
	    case SDL_MOUSEMOTION :
	      if (!paused)
		level->movePads(((double)event.motion.x)/screen_width,
				((double)event.motion.y)/screen_height);
	      break;
	    case SDL_MOUSEBUTTONDOWN :
	      if (!paused)
		level->releaseBalls();
	      break;
	    case SDL_JOYAXISMOTION :
	      //	      printf("%d %d\n",event.jaxis.axis, event.jaxis.value);
	      switch (event.jaxis.axis) {
	      case 0: // vertical
		joyy=event.jaxis.value;
		break;
	      case 1: // horizontal
		joyx=event.jaxis.value;
		break;
	      }

	      break;
	    default:
	      break;
            }
        }

      if (connection) connection->poll();

      /* See if the level has been completed (player losing, and other
	 big things will be taken care of here as well) */
        
    
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); // Clear The Screen And The Depth Buffer
      glLoadIdentity();                                   // Reset The Matrix

      /* bind texture.. */
      //    glEnable( GL_TEXTURE_2D );
    //    glBindTexture(GL_TEXTURE_2D, tex_id);
    // Dois tre rappel  chaque fois !! Sinon a prend le env_mode 
    // du dernier appel
    //    glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE );  
      if (!paused) {

	//	if (!levelDone) { // stop moving stuff around when we're fading out

	if (joyx != 0 || joyy != 0) 
	  level->shiftPads(-joyx*((now-prev)/1000.0)/4000,
			   -joyy*((now-prev)/1000.0)/4000);

	if (!level->update((now-prev)/1000.0)) done=true;
	  //	}
	
	updateCam((now-prev)/1000.0);
      }

      applyCam();

#ifdef DEBUG
      debugCam();
#endif

      /*      lightPos[0] = cosf(now/1000.0f);
      lightPos[1] = 1;
      lightPos[2] = sinf(now/1000.0f);
      lightPos[3] = 0; */
      glLightfv( GL_LIGHT0,GL_POSITION,lightPos);

      level->render();

      /* apply fadeout effect */

//     glBegin (GL_TRIANGLE_FAN);  
//     glNormal3f (0,0,1);
//     glTexCoord2f(0,0);  glVertex3f(-1,-1, 0);
//     glTexCoord2f(1,0);  glVertex3f( 1,-1, 0); 
//     glTexCoord2f(1,1);  glVertex3f( 1, 1, 0);
//     glTexCoord2f(0,1);  glVertex3f(-1, 1, 0);
//     glEnd();
    
    // Swap the backbuffers to the foreground
    SDL_GL_SwapBuffers(); 
    } // while( ! done)
}
