#include <math.h>

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#include "boom.h"
#include "base.h"

Boom::Boom(unsigned int id) : Stone(id) {
  now = 0;
  snow = 0;
}
Boom::~Boom() {}

bool Boom::trigger(Littlecube *b) {
  kill(true);
  return true;
}

void Boom::update(double t, Level *lvl) {
  Stone::update(t,lvl);
  now += t;
  snow = (sin(now)+1)/2;

}

void Boom::render() {

  glColor3f(1,snow,0.0f);
  render0();

}
