#include "hard.h"
#include "base.h"
#include "main.h"

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

Hard::Hard(unsigned int id) : Stone(id) {
  count=5;
}
Hard::~Hard() {}

bool Hard::trigger(Littlecube *b) {
  count--;

  if (count==0) {
    //    crack->play(); // kill makes the noise already
    kill();
    return true;
  } else {
    click[rand()%4].play();
    return false;
  }
}

void Hard::render() {

  glColor3f(0.7f,0.0f,0.0f);
  if (!render0()) return;

  glPushMatrix(); {
    glTranslatef(x,y,0);

  glBegin(GL_QUADS);
  glColor3f(0,0,0);
  glNormal3f(0,0,1);

  if (count>4) {
    glVertex3f(0.2f,0.7f,0.51f);
    glVertex3f(0.3f,0.7f,0.51f);
    glVertex3f(0.3f,0.8f,0.51f);
    glVertex3f(0.2f,0.8f,0.51f);
  }

  if (count>3) {
    glVertex3f(0.7f,0.7f,0.51f);
    glVertex3f(0.8f,0.7f,0.51f);
    glVertex3f(0.8f,0.8f,0.51f);
    glVertex3f(0.7f,0.8f,0.51f);
  }

  if (count>2) {
    glVertex3f(0.7f,0.2f,0.51f);
    glVertex3f(0.8f,0.2f,0.51f);
    glVertex3f(0.8f,0.3f,0.51f);
    glVertex3f(0.7f,0.3f,0.51f);
  }

  if (count>1) {
    glVertex3f(0.2f,0.2f,0.51f);
    glVertex3f(0.3f,0.2f,0.51f);
    glVertex3f(0.3f,0.3f,0.51f);
    glVertex3f(0.2f,0.3f,0.51f);
  }
  glEnd();

  } glPopMatrix();

}
