#ifndef MOVING_H
#define MOVING_H

#include "stone.h"
#include "level.h"

/* A stone that moves around
   
   Copyright (C) 2010 Maxime Gamboni. See COPYING for
   copying/warranty info. */


class Moving : public Stone {
 public:
  /* direction is 0 for horizontal and 1 for vertical. */
  Moving(int direction,bool unbreakable,unsigned int id);
  ~Moving();
  void init(char ch,int x,int y);

  bool breakable();

  double getX();
  double getY();

  double check_collision(double x,double y,double dx,double dy, double *n, double *v,bool triggers=false);

  bool trigger(Littlecube *b);

  void update(double t, Level *lvl);

  void render();

 private:
  double x,y; // position
  double sx,sy; // speed
  double dx,dy; // displacement in previous update()
  bool updating; // true while update() is running
  bool unbreakable;
};

#endif
