#ifndef SLASH_H
#define SLASH_H

#include "stone.h"
#include "level.h"

/* An unbreakable diagonal wall.

   Copyright (C) 2010 Maxime Gamboni. See COPYING for
   copying/warranty info. */


class Slash : public Stone {
 public:
  /* direction is false for / and true for \ */
  Slash(bool direction,unsigned int id);
  ~Slash();
  void init(char ch,int x,int y);

  bool breakable();

  bool trigger(Littlecube *b);

  double check_collision(double x,double y,double dx,double dy, double *n, double *v,bool triggers=false);

  void render();

 private:
  bool dr; // direction
};


#endif
