#ifndef SOUND_H
#define SOUND_H

#include <SDL/SDL_audio.h>

/** A wrapper for SDL_Audio functions. One instance is one sound effect.

    Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */


class Sound {
 public:

  Sound();
  ~Sound();

  /** Attempt to load the given file. Returns true on success */
  bool loadWAV(const char *fn);

  /* Reset the object to save some memory */
  void clean();

  /** Play a sound previously loaded with load() */
  void play();

 private:
  SDL_AudioSpec wave;

  /* Following http://www.libsdl.org/intro.en/usingsound.html, cvt.buf
     contains the audio data */
  SDL_AudioCVT cvt;
  Uint32 dlen;
};

/* Audio mixing playback function */
void mixaudio(void *unused, Uint8 *stream, int len);

#endif
