#include "teleport.h"
#include "base.h"

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

Teleport::Teleport(unsigned int id) : Stone(id) {
  target=0;

  disabled = -1;
}

Teleport::~Teleport() {}

void Teleport::set_target(Teleport *s) {
  this->target = s;
}

bool Teleport::breakable() {
  return false;
}

bool Teleport::trigger(Littlecube *b) {
  if (b) {
    if (disabled<0) {
      b->move(target->getX(),target->getY());
      target->disable();
      this->disable();
    }
  }
  return false;
}

void Teleport::disable() {
  disabled = 4;
}

void Teleport::update(double t, Level *lvl) {
  if (disabled>=0) {
    disabled -= t;
  }
}


void Teleport::render() {

  if (disabled>0)
    glColor3f(0,0,0.4f);
  else
    glColor3f(0.7f,0,1);

  if (!render0()) return;
}
