#ifndef TELEPORT_H
#define TELEPORT_H

/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#include "stone.h"

class Teleport : public Stone {
 public:

  Teleport(unsigned int id);
  ~Teleport();

  void set_target(Teleport *s);

  void render();

  bool breakable();

  bool trigger(Littlecube *b);

  void update(double t, Level *lvl);

  /* disable the teleporter for one second */
  void disable();

 private:

  /* when bigger than zero, tells for how many more seconds this
     should be disabled (un behave like an unbreakable stone) */
  double disabled;

  /* When the ball triggers this stone, send it there */
  Teleport *target;

};

#endif
