/** Copyright (C) 2010 Maxime Gamboni. See COPYING for
    copying/warranty info. */

#ifndef TOOLS_H
#define TOOLS_H

#include <GL/gl.h>

/* #include <vector> */
/* #include <string> */
/* #include <iostream> */
/* #include <sstream> */
/* #include <stdexcept> */

/* #include "../base.h" */

/* using namespace std; */


/* /\** beuh ... *\/ */
/* class BadConversion : public runtime_error  */
/* { */
/* public: */
/*     BadConversion(const string& s) : runtime_error(s) */
/*     {} */
/* }; */


/* /\** Convert a T to a string *\/  */
/* template <typename T> */
/* static string toString(T x) */
/* { */
/*     ostringstream o; */
/*     if (!(o << x))  */
/*         throw BadConversion("toString(T x)"); */
/*     return o.str(); */
/* }  */


/* /\** Convert a string to a T. *\/ */
/* template <typename T> */
/* static bool stringToT( string str, T &x ) */
/* { */
/*     std::istringstream i( str ); */
/*     return (i >> x) ; */
/* }   */


/* /\** @return le premier caractre d'un string *\/ */
/* string firstCharacterOf( const string &str ); */

/* /\** @return le dernier caractre d'un string *\/ */
/* string lastCharacterOf( const string &str ); */

/* /\** Enlve les espaces doubles ou +  l'intrieur du string *\/ */
/* void removeDoubleSpace( const string &str ); */

/* /\**   */
/*  *  Enlve les espaces blancs au dbut, les double espaces au milieu et  */
/*  *   la fin d'un string. */
/*  *\/ */
/* void trim( string &str ); */


/* /\** Convertit les lettre majuscules d'un string en minuscule *\/ */
/* string toLowerCase( string str ); */

/* /\**  */
/*  * Fait la mme chose que glTranslatef, mais en lui donnant un tableau en param. */
/*  * @param a[3] le fameux tableau de float. */
/*  *\/ */
/* void glTranslatefv( float a[3] ); */


/* /\** */
/*  * Interrroge OpenGL sur l'tat du mode de rendu */
/*  * @return en gnral soit GL_RENDER ou GL_SELECT. */
/*  *\/ */
/* int getRenderMode(); */

double sq(double x);

/* Render a cube of width w, height h and depth d with the lowest
   coordinate at (0;0;0). Use setColor and translate and rotate as
   required before calling this. And yes I know it's actually a
   parallelepipede. */
void render_cube(double w,double h, double d, bool rounded=false, double rounding=0.05);

/* Generic line intersection function, checks intersection with an
   horizontal obstacle but you can swap the meaning of x and y to
   test for a vertical obstacle. */
double wall_collision(double x,double y, /* trajectory start */
		    double dx,double dy, /* trajector delta */
		    double wx0, double wx1, /* obstacle x bounds */
		    double wy); /* obstacle y coordinate */

/* Load the given JPEG file into a texture, and store texture id into
   id. Returns false in case of failure **/
bool loadTexture(const char *file, GLuint *id);

/* Load the given PNG file into a texture, and store texture id into
   id. Returns false in case of failure **/
bool loadTexture_png(const char *file, GLuint *id);

/**
 *	Replaces gluPerspective, sets the frustum to perspective mode.
 *	@param fovY	  : Field of vision in degrees in the y direction
 *	@param aspect : Aspect ratio of the viewport
 *	@param zNear  : The near clipping distance
 *	@param zFar	  : The far clipping distance
 */
void glPerspective( GLdouble fovY, GLdouble aspect, GLdouble zNear, GLdouble zFar );
        
#endif  // TOOLS_H
